<template>
  <basic-container>

    <el-dialog :modal-append-to-body="false" :visible.sync="userLabelVisible" title="用户标签" width="50%">
      <el-form ref="labelForm" :model="labelForm" label-width="80px">

        <el-form-item label="用户标签">
          <el-select v-model="labelForm.limitTag" placeholder="请选择用户标签" multiple clearable="true">
            <el-option v-for="item in labelItems" :key="item.dictKey" :label="item.dictValue" :value="item.dictKey">
            </el-option>
          </el-select>
        </el-form-item>

        <el-form-item>
          <el-button type="primary" @click="bindTag">打标签</el-button>
        </el-form-item>
      </el-form>
    </el-dialog>
    <avue-crud :option="option" :table-loading="loading" :data="data" :page.sync="page" :permission="permissionList"
      :before-open="beforeOpen" v-model="form" ref="crud" @row-update="rowUpdate" @row-save="rowSave" @row-del="rowDel"
      @search-change="searchChange" @search-reset="searchReset" @selection-change="selectionChange" @current-change="currentChange"
      @size-change="sizeChange" @refresh-change="refreshChange" @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger" size="small" icon="el-icon-s-check" plain v-if="permission.loginuser_delete" @click="handleDelete">删
          除
        </el-button>
      </template>

      <template slot="menu" slot-scope="scope">
        <el-button type="text" size="small" icon="el-icon-s-check" plain v-if="permission.loginuser_label" @click="handleLabel(scope.row)">标签
        </el-button>
      </template>
      <template slot-scope="scope" slot="avatar">

        <img style="width: 70px; height: 50px; " :src="scope.row.avatar" :fit="fit" @click="openView(scope.row.avatar)">
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
    import request from '@/router/axios';
  import {
    getList,
    getDetail,
    add,
    update,
    remove
  } from "@/api/loginuser/loginuser";
  import {
    mapGetters
  } from "vuex";

  export default {
    data() {
      return {
        labelItems: [],
        labelForm: {
          limitTag: [],
        },
        userLabelVisible: false,
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height: 'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          column: [{
              label: "用户昵称",
              prop: "nickName",
              width: 150,
              search: true,
              rules: [{
                required: true,
                message: "请输入用户昵称",
                trigger: "blur"
              }]
            },
            {
              label: "用户头像",
              prop: "avatar",
              width: 120,
              slot: true,
              rules: [{
                required: true,
                message: "请输入用户头像",
                trigger: "blur"
              }]
            },
            {
              label: "手机号",
              prop: "phone",
              width: 100,
              search: true,
              rules: [{
                required: true,
                message: "请输入手机号",
                trigger: "blur"
              }]
            },
            {
              label: "性别",
              prop: "gender",
              type: "select",
              width: 80,
              dicData: [{
                  label: "未知",
                  value: 0
                },
                {
                  label: "男",
                  value: 1
                },
                {
                  label: "女",
                  value: 2
                }
              ],
              rules: [{
                required: true,
                message: "请输入0：未知 1：男 2：女",
                trigger: "blur"
              }]
            },



            {
              label: "可用积分",
              prop: "usablePoints",
              width: 150,
              rules: [{
                required: true,
                message: "请输入可用积分",
                trigger: "blur"
              }]
            },
            {
              label: "总积分",
              prop: "totalPoints",
              rules: [{
                required: true,
                message: "请输入总积分",
                trigger: "blur"
              }]
            },
            {
              label: "可用热力",
              prop: "usableHot",
              width: 150,
              rules: [{
                required: true,
                message: "请输入可用热力",
                trigger: "blur"
              }]
            },
            {
              label: "总热力",
              prop: "totalHot",
              width: 150,
              rules: [{
                required: true,
                message: "请输入总热力",
                trigger: "blur"
              }]
            },
            {
              label: "openid",
              prop: "openid",
              width: 200,
              rules: [{
                required: true,
                message: "请输入openid",
                trigger: "blur"
              }]
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.loginuser_add, false),
          viewBtn: this.vaildData(this.permission.loginuser_view, false),
          delBtn: this.vaildData(this.permission.loginuser_delete, false),
          editBtn: this.vaildData(this.permission.loginuser_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      },

    },
    methods: {
      handleLabel(row) {
        if(row.limitTag != undefined || row.limitTag == ""){
          this.labelForm.limitTag = row.limitTag.split(",");
        }else{
           this.labelForm.limitTag = []
        }
        this.labelForm.id = row.id;

        this.userLabelVisible = true;
        request({
          url: '/api/blade-system/dict/dictionary?code=login_user_limit_label',
          method: "get",
        }).then(res => {
          this.labelItems = res.data.data;

        })

      },
      bindTag(){
        this.labelForm.limitTag = this.labelForm.limitTag.join(",")
        request({
          url: '/api/cyzh-loginUser/loginuser/bindTag',
          method: "post",
          data: this.labelForm
        }).then(() => {
            this.userLabelVisible = false;
        })
      },
      openView(url) {
        var data = [{
          thumbUrl: url,
          url: url
        }];
        this.$ImagePreview(data, 0);
      },
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
            confirmButtonText: "确定",
            cancelButtonText: "取消",
            type: "warning"
          })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
            confirmButtonText: "确定",
            cancelButtonText: "取消",
            type: "warning"
          })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage) {
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize) {
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
